#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>

#include "..\autoit-opencv-com\udf\opencv_udf_utils.au3"

Global $tmpl
Global $aRect, $iLeft, $iTop, $iWidth, $iHeight
Global $cv

Global Const $Ask_On_Found = 0
Global Const $Mouse_Move_On_Found = 1
Global Const $Mouse_Click_On_Found = 0
Global Const $iSleep_Time=500
Global $sCount = 0
Global $mCount = 0
Global $iCount = 0
;, $_Image_1 = @ScriptDir & "\butonimage.bmp"
Global $_Image_1 ="butonimage.bmp"
Global $_title_1 =  "autoimageclose"

_OpenCV_Open(_OpenCV_FindDLL("opencv_world470*"), _OpenCV_FindDLL("autoit_opencv_com470*"))
OnAutoItExitRegister("_OnAutoItExit")
HotKeySet("{Esc}", "_Exit") ; Press ESC for exit

Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
$mainwindow = GUICreate($_title_1, 140,80)
GUISetOnEvent($GUI_EVENT_CLOSE, "CLOSEClicked")
$msg1="stopping"
$label1=GUICtrlCreateLabel($msg1, 10, 10)
$button1 = GUICtrlCreateButton("push", 10, 20,50, 25)
;$button2 = GUICtrlCreateButton("set", 10, 50,50, 25)
GUICtrlSetOnEvent($button1, "OKButton")
;GUICtrlSetOnEvent($button2, "OKButton2")
$Pic1 = GUICtrlCreatePic($_Image_1, 70, 20, 50, 50)
$label2=GUICtrlCreateLabel("image", 80,40)
GUICtrlSetColor($label2, 0xff0000)
GUICtrlSetBkColor($label2, $GUI_BKCOLOR_TRANSPARENT)


GUISetState(@SW_SHOW)
WinWait($_title_1)
WinActivate($_title_1)
WinSetOnTop($_title_1, "", 1)

$cv = _OpenCV_get()
If Not IsObj($cv) Then Exit
_Initialize()

While 1
	Sleep($iSleep_Time)
  if $msg1="stopping"  Then
  Else
   _osu()
  EndIf
WEnd

Func _osu()
	$sCount += 1
	ConsoleWrite("Rect: [" & $iWidth & " x " & $iHeight & " from (" & $iLeft & ", " & $iTop & ")]" & @CRLF)

	; The higher the value, the higher the match is exact
	Local $threshold = 0.8

	$img = _OpenCV_GetDesktopScreenMat($aRect)
	if $iCount=0 Then
	; Ignore the alpha channel when matching the template => $CV_COLOR_BGRA2BGR
	; Only consider gray scale colors when matching the template => $CV_COLOR_BGRA2GRAY
	; using cveCanny and/or gray scale can significantly reduce the matching time but also reduce the matching accuracy
	$aMatches = 0

	Global $aMatches = _OpenCV_FindTemplate($img, $tmpl, $threshold, Default, Default, Default, $CV_COLOR_BGRA2GRAY)

	Local $iMatches = UBound($aMatches)
	ConsoleWrite("Number of matches: " & $iMatches & @CRLF)
	$iCount = $iMatches
	$mCount = $iMatches
	EndIf

	if $iCount<>0 Then
	$ix = $mCount - $iCount
	$iCount -=1
	Local $aMatchRect = _OpenCV_Rect(0, 0, $tmpl.width, $tmpl.height)

;	For $i = 0 To $iMatches - 1
		$aMatchRect[0] = $aMatches[$ix][0]
		$aMatchRect[1] = $aMatches[$ix][1]
        ConsoleWrite('- [' & $sCount & '] Image found:' & " X=" & $aMatchRect[0] & " Y=" & $aMatchRect[1] & @CRLF)
        If $Mouse_Move_On_Found Then
			MouseMove($aMatchRect[0], $aMatchRect[1])
			Sleep($iSleep_Time)
		EndIf
        If $Mouse_Click_On_Found Then MouseClick("left", $aMatchRect[0], $aMatchRect[1])
        ToolTip('(' & $sCount & "] Image found:" &  " X=" & $aMatchRect[0] & " Y=" & $aMatchRect[1], 1, 1)
;	Next
	EndIf
EndFunc   ;==>Search

Func _Initialize()
;	$tmpl = $cv.imread(_OpenCV_FindFile($_Image_1))
	$tmpl = $cv.imread(_OpenCV_FindFile("samples\data\mario_coin.png"))

	; Search on the first screen. Leave empty to search on all screens
	; Reducing the search area improves the search time
	$aRect = _OpenCV_GetDesktopScreenRect(1)
	$iLeft = $aRect[0]
	$iTop = $aRect[1]
	$iWidth = $aRect[2]
	$iHeight = $aRect[3]
EndFunc   ;==>_Initialize

Func _Release()
	#comments-start
	#comments-end
	$cv.destroyAllWindows()

EndFunc   ;==>_Release

Func _OnAutoItExit()
	_GDIPlus_Shutdown()
	_OpenCV_Close()
EndFunc   ;==>_OnAutoItExit

Func OKButton()
;  MsgBox(0, "GUI Event", "You pressed OK!")
if $msg1="stopping"  Then
  $msg1="executing"
Else
  $msg1="stopping"
EndIf
GUICtrlSetData ($label1, $msg1)
EndFunc

#comments-start

Func OKButton2()
MsgBox(64 + 262144, 'ImageSearch', 'At first, create a file bmp,' & @CRLF & 'photos that will search on the screen!')
;_ImageSearch_Create_BMP($_Image_1)
ConsoleWrite(" Save image: " & $_Image_1 & @CRLF )
Sleep(1000)
GUICtrlSetImage ($Pic1,$_Image_1)
EndFunc
#comments-end

Func CLOSEClicked()
	_Release()
Exit
EndFunc


Func _Exit()
	_Release()
    Exit 0
EndFunc   ;==>_Exit

